﻿function getOutlookHostedWindow() {
    return window.external;
}



function PrepareUrlArguments() {

    window.urlVars = new Object();

    var searchString = document.location.search;
    searchString = searchString.substring(1);

    var nvPairs = searchString.split("&");

    for (i = 0; i < nvPairs.length; i++) {
        var nvPair = nvPairs[i].split("=");
        var name = nvPair[0];
        var value = nvPair[1];

        window.urlVars[name] = value;

    }
}


function OpenWindowOutlookAware(inUrl, inName, inHeight, inWidth, inType) {
    PrepareUrlArguments();

    var isIFD = false;
    var isOutlook = false;

    var typeCode = inType;
    var typeName = "";


    if (window.urlVars["isIFD"] == "true")
        isIFD = true;

    if (window.urlVars["isOutlook"] == null) {
        try 
        {
            var context;
            try 
            {
                context = GetGlobalContext();
            }
            catch (ex) 
            {
                context = Xrm.Page.context;
            }

            isOutlook = context.isOutlookClient();
        }
        catch (e) {
        }
    }
    else 
    {
        if (window.urlVars["isOutlook"] == "true")
            isOutlook = true;
    }

    //if (window.urlVars["isOutlook"] == "true")
    //    isOutlook = true;

    if (inUrl) {
        if (isOutlook) {

            if (!(typeCode)) {
                try {
                    var startPos = inUrl.toString().indexOf("etn=", 0) + 4;
                    if (startPos > 4)
                        typeName = inUrl.toString().substr(startPos, inUrl.toString().indexOf("&", startPos + 1) - startPos);



                    if (typeName.toLowerCase() == "appointment")
                        typeCode = 4201;
                    else if (typeName.toLowerCase() == "task")
                        typeCode = 4212;
                    else if (typeName.toLowerCase() == "phonecall")
                        typeCode = 4210;
                    else if (typeName.toLowerCase() == "email")
                        typeCode = 4202;
                    else if (typeName.toLowerCase() == "letter")
                        typeCode = 4207;
                    else if (typeName.toLowerCase() == "serviceappointment")
                        typeCode = 4214;
                    else if (typeName.toLowerCase() == "fax")
                        typeCode = 4204;

                }
                catch (e)
                { }

                if (!(typeCode)) {
                    try {
                        var startPos = inUrl.toString().indexOf("etc=", 0) + 4;
                        if (startPos > 4)
                            typeCode = inUrl.toString().substr(startPos, inUrl.toString().indexOf("&", startPos + 1) - startPos);

                    }
                    catch (e)
                    { }
                }
            }


            if (typeCode) {

                var $v_V = getOutlookHostedWindow().openInspector(typeCode, inUrl.toString(), inWidth, inHeight);
                // if (!IsNull($v_V))

                if ($v_V)
                    $v_V.opener = window.self;

                return $v_V;
            }
            else {
                return openStandardWindow(inUrl, inName, inWidth, inHeight);
            }
        }
        else {
            return openStandardWindow(inUrl, inName, inWidth, inHeight);
        }
    }
}


function openStandardWindow(sPath, sName, iX, iY) {
    if (!iX)
        iX = 750;
    if (!iY)
        iY = 510;


    try {

        var additionalParam = "&histKey=genericap&newWindow=true";
        var thiswindow = window.open(sPath + additionalParam, sName, "width=" + iX + ",height=" + iY + ",status=1,resizable=1");

        currentWindow = thiswindow;

        return currentWindow;

    }
    catch (e) { alert('error: ' + e.description); }
}

